//goldenRatioMythTester (C) Loe Feijs and TU/e 2016
//Interactive tool to debunk or confirm presence of golden ratio in images.
//The image must be called "sample.jpg" (put in same folder as .pde source).
//The pacman sounds must be in a folder called "data". 
//Accuracy criterion: 5%

PImage sample; 

int x1 = 100;//initial rectangle is golden
int y1 = 100;
int x2 = 200;
int y2 = 262;

import ddf.minim.*;
Minim minim;
AudioPlayer fruit;
AudioPlayer dead;


void setup(){
     sample = loadImage("sample.jpg");
     size(sample.width + 40,sample.height + 40);
     minim = new Minim(this);
     fruit = minim.loadFile("fruit.wav");//from pacman
     dead  = minim.loadFile("dead.wav");//thanks tori iwatani
     println("USE MOUSE TO MOVE CORNERS, ALIGNING RECTANGLE");
     println("...THEN HIT SPACEBAR TO TEST FOR GOLDEN RATIO");
}


void draw(){
     tint(255, 126);  //transparency
     image(sample,20,20);
     //draw the two corner points 
     stroke(100,255,100); noFill(); 
     ellipse(x1,y1,6,6); ellipse(x1,y1,12,12);
     ellipse(x2,y2,6,6); ellipse(x2,y2,12,12);
     //draw the selected rectangle 
     int w = x2 - x1;
     int h = y2 - y1;
     line(x1,y1,x1 + w,y1);
     line(x1 + w ,y1,x1 + w,y1 + h);
     line(x1 + w,y1 + h,x1,y1 + h);
     line(x1     ,y1 + h,x1    ,y1);
     //drag the corner points with the mouse
     if (mousePressed){
         //drag the point being near the mouse
         if (dist(x1,y1,mouseX,mouseY) < 40){
                  x1 = mouseX;
                  y1 = mouseY;
         }
        else if (dist(x2,y2,mouseX,mouseY) < 40){
                  x2 = mouseX;
                  y2 = mouseY;
        }
     }
}    //end draw

void keyPressed() {
  if (key == ' ') {
      test(x2 - x1,y2 - y1);
  } 
}

void test(int dx,int dy){
     //test whether the ratio is close to the golden ratio
     final float phi = 1.61810339887;
     //find the ratio and compare to phi
     float a = abs(dx);
     float b = abs(dy);
     if (a == 0) a = 1;
     if (b == 0) b = 1;
     float ratio;
     if (a > b)
        ratio = a / b;
        else ratio = b / a;
     //provide feedback to the user (message window + sound)
     print(ratio); 
     if (ratio/phi < 1.05 && ratio/phi > 0.95){
         println(" okay (within 5% accuracy)");
         dead.pause(); fruit.rewind(); fruit.play();
     }
     else { println(" not okay (ratio differs at least 5% compared to phi)");
            fruit.pause(); dead.rewind(); dead.play();
     }
}
